;************************************************
;LEKCJA   5	- STOS
;PRZYKAD 3	- KALKULATOR MNOENIE BCD
;************************************************

	LJMP	START
	ORG	100H
START:

	LCALL	LCD_CLR

	LCALL	WAIT_KEY	;pobierz pierwszy czynnik
	MOV	R0,A		;zapamitaj w R0
	ACALL	WRITE_BCD	;wypisz w postaci BCD

	MOV	A,#'*'		;znak iloczynu
	LCALL	WRITE_DATA

	LCALL	WAIT_KEY	;pobierz drugi czynnik
	MOV	R1,A		;zapamitaj w R1
	ACALL	WRITE_BCD	;wypisz w postaci BCD

	MOV	A,#'='		;znak rwnoci
	LCALL	WRITE_DATA

	MOV	A,R0		;pomn oba czynniki
	MOV	B,R1
	MUL	AB
	ACALL	WRITE_BCD	;wypisz wynik
				;w postaci BCD
	SJMP	$

;**************************************
;podprogram wypisuje liczb z akumulatora
;na wywietlacz LCD w postaci BCD

WRITE_BCD:
	MOV	B,#100		;wydziel setki
	DIV	AB
	JZ	ONLY_LOW	;wypisz setki jeli 
	LCALL	WRITE_HEX	;rne od 0

ONLY_LOW:
	MOV	A,B		;wydziel dzesitki
	MOV	B,#10
	DIV	AB
	SWAP	A
	ORL	A,B		;pocz z jednostkami
	LCALL	WRITE_HEX	;pisz dziesitki i jedn.

	RET			;koniec podprogramu
